//go:build windows
// +build windows

package user

import "golang.org/x/sys/windows"

func windowsAudio() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Music, 0)
	return path, err
}

func windowsDesktop() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Desktop, 0)
	return path, err
}

func windowsDocuments() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Documents, 0)
	return path, err
}

func windowsDownloads() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Downloads, 0)
	return path, err
}

func windowsPictures() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Pictures, 0)
	return path, err
}

func windowsPublic() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Public, 0)
	return path, err
}

func windowsTemplates() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Templates, 0)
	return path, err
}

func windowsVideos() (string, error) {
	path, err := windows.KnownFolderPath(windows.FOLDERID_Videos, 0)
	return path, err
}
